#define BLYNK_PRINT SerialUSB
#define BLYNK_DEBUG SerialUSB
#include "ArduinoExpension.h"
/*
	Waves
  Nothing is more painful then waking up in the morning, not knowing if the surf is good and if your surf partner is still sleeping. 
  For that reason we made the Wave Prediction Alarm Clock.
The program uses connections with Blynk and Make to make an Alarm clock which uses the friendship power through Telegram!
Once you set the Alarm in Blynk, it will send a telegram message to your friend to let him know.
Once the Alarm clock turns on, you will have to shout at it and touch A1,A2,A3 while your feet are on the ground (to make sure you woke up (; )
Untill you wake up, your friend gets telegram messages to let him know you are trying to wake up and need help.
After you completed the tasks, we use again the integration with telegram to let your friend know you are up, wave prediction and water temperature.
As a bonus for your dedication to waking up, the CPX will indicate if the surf is good using it's leds. Green LED - no surf.
1 Blue LED - surf might be proper, 2 Blue LEDS - surf is good, 3 Blue LEDS - high waves!
Good Luck!


	Video link: a link to a video showing your work.
	Created By:
  Eyal_Zawlik#315874115
  Nadav_Morag#313261265
*/ 


//https://sgp1.blynk.cloud/external/api/update?token={token}&{pin}={value}
// blynk-cloud.com/G0q_J0Mzr5PCPhJ3Lpb00sUzx7-UX_db/update/V0?value=50
#define BLYNK_TEMPLATE_ID "TMPL6Aecz9oD"
#define BLYNK_TEMPLATE_NAME "Final Project"
#define BLYNK_AUTH_TOKEN "X8z-2RpN4Y9YCpTzmpYnRqVLhBscvUko"

#include <ESP8266_Lib.h>
#include <BlynkSimpleShieldEsp8266.h>
#include <Adafruit_CircuitPlayground.h>

char auth[] = BLYNK_AUTH_TOKEN;

// Your WiFi credentials.
// Set password to "" for open networks.
//char timeNow[] = "https://timeapi.io/api/Time/current/coordinate?&latitude=32.0809&longitude=34.7806";
char ssid[] = "Morag";
char pass[] = "0506519997";
//char server[]= "https://eu1.make.com";
//char waveJson[] = "http://my.meteoblue.com/packages/sea-day?apikey=vHlMhYFcD750yVom&lat=32.0809&lon=34.7806&asl=15&format=json";
const char server[] = "hook.eu1.make.com";
const char resource[] = "/z93rjidnrkmgnfg8a7ith4h2lcdc1how?message=קמתי אחשלי בוקר טוב";

#define EspSerial Serial1
#define ESP8266_BAUD 115200

ESP8266 wifi(&EspSerial);

long last_sent = 0;
int mode = 0;
int newMode = 0;
boolean isWokeUp = false;
boolean timeToWakeUp = false;
boolean alarmSet = false;
boolean isTimeUpdated = false;
String AlarmTime="18:42";
int hourAlarm = AlarmTime.substring(0,2).toInt();
int minuteAlarm = AlarmTime.substring(3).toInt();
int hourNow = 0;
int minuteNow = 0;
String TimeNow;
int delayAcc = 0;
unsigned long previousMillis;
unsigned long millisToWakeUp = 4294967295;
unsigned long currentMillis = millis();
unsigned long sixtySecondsTimer = millis();

void setup() {
  //CircuitPlayground.begin();
  arduinoSetup();
  SerialUSB.begin(9600);
  EspSerial.begin(ESP8266_BAUD);
  delay(10);
  Blynk.begin(auth, wifi, ssid, pass);

  //timer.setInterval(500L, ModeChanger);
}

BLYNK_CONNECTED() {
    Blynk.syncVirtual(V7,V8,V5);
}

void addMinute(){
    sixtySecondsTimer-= (60*1000);
    if(minuteNow == 59){
      minuteNow = 0;
      if(hourNow == 23){
        hourNow = 0;
      }
      else{
        hourNow++;
      }
    }
    else{
      minuteNow++;
    }
    if(hourNow == hourAlarm && minuteNow == minuteAlarm){
      timeToWakeUp = true;
      isWokeUp = false;
      //ringTheAlarm();
  }
  String Nekudotaim = ":";
  String hour = "0";
  String minute = "0";
  if(hourNow < 10){
    hour = hour+hourNow;
  }
  else{
    hour = hourNow;
  }
  if(minuteNow < 10){
    minute = minute+minuteNow;
  }
  else{
    minute = minuteNow;
  }
  Nekudotaim = hour + Nekudotaim;
  Nekudotaim = Nekudotaim + minute;
  Blynk.virtualWrite(V3,Nekudotaim);
  Serial.println(Nekudotaim);
  Serial.println(hourAlarm);
  Serial.println(minuteAlarm);
}

void loop() {
  sixtySecondsTimer = millis();
  if(sixtySecondsTimer - previousMillis >= 60*1000){
    previousMillis = sixtySecondsTimer;
    addMinute();
    Serial.println(minuteNow);
  }
  Blynk.run();
  if(alarmSet){
    if(timeToWakeUp){
      if(!isWokeUp){
        // if(delayAcc > 0){
        //   delayAcc-= 1000;
        //   delay(1000);
        // }
        // else{

          //delayAcc = 10000;
          Blynk.virtualWrite(V1, "אחי תעיר אותי אני לא מצליח לקום");
          alarmSound();
          if(sound>70&&allWereTouched){
            isWokeUp= true;
          }
        // }
      }
      else{
        Blynk.virtualWrite(V1,"קמתי אחשלי בוקר טוב");
        //delayAcc = 0;
        //timeToWakeUp = false;
      }
    }
  }
}

//Wave height
BLYNK_WRITE(V0) {
  double pinValue = param.asDouble(); // assigning incoming value from pin V0 to a variable
  timeToWakeUp = false;
  WaveHandler(pinValue);
  Serial.println(pinValue);
}

//integration with Make
BLYNK_WRITE(V1) {
  String pinValue = param.asStr(); // assigning incoming value from pin V1 to a variable
  Serial.println(pinValue);
}

//Time Now
BLYNK_WRITE(V3) {
  //previousMillis = currentMillis;
  // currentMillis = millis(); 
   String pinValue = param.asStr(); // assigning incoming value from pin V3 to a variable
  TimeNowUpdate(pinValue); // this function uses time now to calculate when to wake up
  Serial.println(pinValue);
    if(hourNow == hourAlarm && minuteNow == minuteAlarm){
      timeToWakeUp = true;
      isWokeUp = false;
      //ringTheAlarm();
  }
}

//alarm on or off
BLYNK_WRITE(V5) {
  int pinValue = param.asInt(); // assigning incoming value from pin V5 to a variable
  Serial.println(pinValue);
    if(pinValue == 1){ //alarm on
    Blynk.virtualWrite(V4, AlarmTime);
    Blynk.virtualWrite(V1, AlarmTime);
    alarmSet = true;
    isWokeUp = false;
    timeToWakeUp = false;
  }
  if(pinValue == 0){ //alarm off
    Blynk.virtualWrite(V4, "Alarm off");
    Blynk.virtualWrite(V1,"Alarm off");
    alarmSet = false;
    isWokeUp = false;
    timeToWakeUp = false;
  }
}

//Hour to wake up
BLYNK_WRITE(V7) {
  int pinValue = param.asInt(); // assigning incoming value from pin V7 to a variable
  hourAlarm = pinValue;
  updateAlarmTimePin();
  Serial.println(pinValue);
}

//Minute to wake up
BLYNK_WRITE(V8) {
  int pinValue = param.asInt(); // assigning incoming value from pin V8 to a variable
  minuteAlarm = pinValue;
  updateAlarmTimePin();
  Serial.println(pinValue);
}

void updateAlarmTimePin(){
  String Nekudotaim = ":";
  String hour = "0";
  String minute = "0";
    if(hourAlarm < 10){
    hour = hour+hourAlarm;
  }
  else{
    hour = hourAlarm;
  }
  if(minuteAlarm < 10){
    minute = minute+minuteAlarm;
  }
  else{
    minute = minuteAlarm;
  }
  AlarmTime = hour + Nekudotaim;
  AlarmTime = AlarmTime + minute;

  if(alarmSet){
    Blynk.virtualWrite(V4, AlarmTime);
    Blynk.virtualWrite(V1,AlarmTime);
  }    
}

void TimeNowUpdate(String pinValue){
  hourNow = pinValue.substring(0,2).toInt();
  minuteNow = pinValue.substring(3).toInt();

}
